=== debian/changelog ===
deepin-unioncode (1.3.8) unstable; urgency=medium

  * Fix some bugs

 -- luzhen <luzhen@uniontech.com>  Wed, 07 Aug 2024 10:11:48 +0800

deepin-unioncode (1.3.7) unstable; urgency=medium

  * Optimize searcher
  * Add symbol tree
  * Add linglong
  * bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 22 Jul 2024 16:32:09 +0800

deepin-unioncode (1.3.4) unstable; urgency=medium

  * Bug fix
  * Optimize LSP

 -- luzhen <luzhen@uniontech.com>  Wed, 26 Jun 2024 15:31:26 +0800

deepin-unioncode (1.3.1) unstable; urgency=medium

  * Change toolbar layout
  * Optimize debugger
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 03 Jun 2024 13:48:11 +0800

deepin-unioncode (1.3.0) unstable; urgency=medium

  * Add file manager plugin template
  * Add git in editor
  * Add process plugin

 -- luzhen <luzhen@uniontech.com>  Fri, 17 May 2024 15:16:33 +0800

deepin-unioncode (1.2.18) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Wed, 24 Apr 2024 17:08:30 +0800

deepin-unioncode (1.2.17) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Sun, 07 Apr 2024 13:31:00 +0800

deepin-unioncode (1.2.16) unstable; urgency=medium

  * Optimize editor
  * Optimize debugger
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 02 Apr 2024 16:47:51 +0800

deepin-unioncode (1.2.15) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 18 Mar 2024 17:42:15 +0800

deepin-unioncode (1.2.14) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 07 Mar 2024 10:35:04 +0800

deepin-unioncode (1.2.13) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Wed, 06 Mar 2024 14:46:49 +0800

deepin-unioncode (1.2.12) unstable; urgency=medium

  * Project tree optimization
  * LSP optimization

 -- luzhen <luzhen@uniontech.com>  Fri, 01 Mar 2024 14:44:12 +0800

deepin-unioncode (1.2.11) unstable; urgency=medium

  * LSP optimization
  * Add locator
  * Add extension manager

 -- luzhen <luzhen@uniontech.com>  Wed, 21 Feb 2024 14:49:42 +0800

deepin-unioncode (1.2.10) unstable; urgency=medium

  * Replace editor
  * Refactor core
  * Optimize project manager

 -- luzhen <luzhen@uniontech.com>  Mon, 05 Feb 2024 10:27:32 +0800

deepin-unioncode (1.2.9) unstable; urgency=medium

  * bug fix.

 -- luzhen <luzhen@uniontech.com>  Wed, 03 Jan 2024 10:12:22 +0800

deepin-unioncode (1.2.8) unstable; urgency=medium

  * Community v23

 -- luzhen <luzhen@uniontech.com>  Thu, 21 Dec 2023 16:16:49 +0800

deepin-unioncode (1.2.7) unstable; urgency=medium

  * Community version

 -- luzhen <luzhen@uniontech.com>  Tue, 19 Dec 2023 17:47:40 +0800

deepin-unioncode (1.2.6) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 19 Dec 2023 16:27:28 +0800

deepin-unioncode (1.2.5) unstable; urgency=medium

  * Fix the problem of blurry icons in launcher and taskbar
  * Fixed syntax highlighting exception after upgrade
  * Improve the About dialog box
  * Fix the problem that the dde-clipboard project tree cannot be displayed
  * Add loading animation during startup
  * Zhipu AI model is updated to support querying DTK related issues. 

 -- luzhen <luzhen@uniontech.com>  Mon, 18 Dec 2023 21:46:03 +0800

deepin-unioncode (1.2.4) unstable; urgency=medium

  * add clangd-13
  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 15 Dec 2023 10:38:26 +0800

deepin-unioncode (1.2.3) unstable; urgency=medium

  * compile on multi-platforms

 -- luzhen <luzhen@uniontech.com>  Wed, 13 Dec 2023 13:18:49 +0800

deepin-unioncode (1.2.2) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 12 Dec 2023 21:00:19 +0800

deepin-unioncode (1.2.1) unstable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 08 Dec 2023 17:47:43 +0800

deepin-unioncode (1.2.0) unstable; urgency=medium

  * Add Codegeex plugin
  * Change qt to dtk

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Mon, 04 Dec 2023 10:04:27 +0800

deepin-unioncode (1.1.20) unstable; urgency=medium

  * 

 -- Deepin Packages Builder <pakcages@linuxdeepin.com>  Fri, 20 Oct 2023 14:07:51 +0800

deepin-unioncode (1.1.19) unstable; urgency=medium

  * 

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Fri, 01 Sep 2023 19:35:11 +0800
