=== debian/control ===
Source: deepin-unioncode
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>=9),
 cmake,
 qt5-qmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev[!loong64],
 lxqt-build-tools (>= 0.6.0~),
 libssl-dev,
 llvm (>=1:7~),
 llvm-dev (>=1:7~),
 libclang-dev (>=1:7~),
 libutf8proc-dev,
 libmicrohttpd-dev,
 libjsoncpp-dev,
 libargtable2-dev,
 libhiredis-dev,
 catch,
 libzstd-dev,
 libjson-c-dev,
 libelf-dev,
 libcapstone-dev,
 libunwind-dev, 
 libelfin-dev,
 libdbus-1-dev,
 libxi-dev,
 qtscript5-dev,
 libqt5scripttools5,
 clang[!mips64],
 doxygen,
 libdtkgui-dev,
 libdtkwidget-dev,
 libdtkcore-dev,
 libdtkcore5-bin,
 libkf5syntaxhighlighting-dev,
 libyaml-cpp-dev
Standards-version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-unioncode
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends: cmake,
            make,
            gdb,
            g++,
            gcc,
            git,
            clangd-13|clangd,
            python3-pip
Description: IDE 'Deepin Union Code'
 Lightweight cross-platform integrated development environment

Package: libdeepin-unioncode-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: IDE 'Union Code' devel library
 IDE 'Union Code' development can be carried out through this library
